/*
 *  EvRA - Event Routing Application
 *
 *  Copyright (C) 2004  Simon Budig <simon@budig.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __EVRA_ACTION_H__
#define __EVRA_ACTION_H__

#include "evra.h"

#define EVRA_TYPE_ACTION            (evra_action_get_type ())
#define EVRA_ACTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), EVRA_TYPE_ACTION, EvraAction))
#define EVRA_ACTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), EVRA_TYPE_ACTION, EvraActionClass))
#define EVRA_IS_ACTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EVRA_TYPE_ACTION))
#define EVRA_IS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EVRA_TYPE_ACTION))
#define EVRA_ACTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), EVRA_TYPE_ACTION, EvraActionClass))


typedef struct _EvraAction      EvraAction;
typedef struct _EvraActionClass EvraActionClass;

struct _EvraAction
{
  GObject  parent_instance;

  /*< private >*/
  gdouble  feedback;
};

struct _EvraActionClass
{
  GObjectClass  parent_class;

  /* signals */
  void    (* feedback_changed) (EvraAction *object);

  /*  virtual functions  */
  void    (* handle_event)     (EvraAction       *action,
                                EvraEvent        *event);
  gdouble (* get_feedback)     (const EvraAction *action);
};


GType         evra_action_get_type         (void) G_GNUC_CONST;
                                          
void          evra_action_handle_event     (EvraAction       *action,
                                            EvraEvent        *event);

void          evra_action_feedback_changed (EvraAction       *action);
gdouble       evra_action_get_feedback     (const EvraAction *action);


#endif  /* __EVRA_ACTION_H__ */
